"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const iconv_lite_1 = tslib_1.__importDefault(require("iconv-lite"));
const http_1 = require("@reactive-js/http");
const node_1 = require("@reactive-js/node");
const option_1 = require("@reactive-js/option");
const pipe_1 = require("@reactive-js/pipe");
const httpContentEncoding_1 = require("./httpContentEncoding");
const async_enumerable_1 = require("@reactive-js/async-enumerable");
exports.decodeHttpMessage = (message, options = {}) => {
    const { body, contentInfo } = message;
    return option_1.isSome(contentInfo) && contentInfo.contentEncodings.length > 0
        ? Object.assign(Object.assign({}, message), { body: contentInfo.contentEncodings
                .map(encoding => httpContentEncoding_1.createEncodingDecompressTransform(encoding, options))
                .reduceRight((acc, decoder) => pipe_1.pipe(acc, node_1.transform(decoder)), body), content: Object.assign(Object.assign({}, contentInfo), { contentEncodings: [], contentLength: -1 }) }) : message;
};
exports.encodeCharsetHttpMessage = (contentType) => {
    var _a;
    const parsedContentType = typeof contentType === "string"
        ? http_1.parseMediaTypeOrThrow(contentType)
        : contentType;
    const charset = (_a = parsedContentType.params["charset"]) !== null && _a !== void 0 ? _a : "utf-8";
    return response => {
        const { body } = response, responseWithoutBody = tslib_1.__rest(response, ["body"]);
        const buffer = iconv_lite_1.default.encode(response.body, charset);
        const streamBody = async_enumerable_1.ofValueStream(buffer);
        return Object.assign(Object.assign({}, responseWithoutBody), { body: streamBody, contentInfo: {
                contentType: parsedContentType,
                contentLength: buffer.length,
                contentEncodings: [],
            } });
    };
};
//# sourceMappingURL=httpMessage.js.map