"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const mime_db_1 = tslib_1.__importDefault(require("mime-db"));
const http_1 = require("@reactive-js/http");
const node_1 = require("@reactive-js/node");
const option_1 = require("@reactive-js/option");
const pipe_1 = require("@reactive-js/pipe");
const httpContentEncoding_1 = require("./httpContentEncoding");
const httpMessage_1 = require("./httpMessage");
exports.decodeHttpRequest = (options = {}) => request => httpMessage_1.decodeHttpMessage(request, options);
exports.encodeHttpRequest = (options = {}) => request => {
    var _a;
    const { body, contentInfo } = request;
    const contentEncoding = httpContentEncoding_1.getFirstSupportedEncoding((_a = request === null || request === void 0 ? void 0 : request.acceptedEncodings) !== null && _a !== void 0 ? _a : []);
    return option_1.isSome(contentEncoding) &&
        option_1.isSome(contentInfo) &&
        contentInfo.contentEncodings.length === 0 &&
        http_1.httpRequestIsCompressible(request, mime_db_1.default)
        ? Object.assign(Object.assign({}, request), { body: pipe_1.pipe(body, node_1.transform(httpContentEncoding_1.createEncodingCompressTransform(contentEncoding, options))), contentInfo: Object.assign(Object.assign({}, contentInfo), { contentEncodings: [contentEncoding], contentLength: -1 }) }) : request;
};
exports.encodeCharsetHttpRequest = (contentType) => {
    const messageEncoder = httpMessage_1.encodeCharsetHttpMessage(contentType);
    return req => messageEncoder(req);
};
//# sourceMappingURL=httpRequest.js.map